#pragma semicolon 1

/*Credits:
 * Original Idea by: ProdigySim
 * Code by: Dr!fter
 * CSGO Support and Added Stocks by: SavSin
*/
#include "adt_trie.inc"
#include "string.inc"
#include "cstrike.inc"
#include "string.inc"

static Handle:hWeaponInfoTrie;

enum WeaponID
{
	WEAPON_NONE,
	WEAPON_GLOCK,
	WEAPON_USP,
	WEAPON_P228,
	WEAPON_DEAGLE,
	WEAPON_FIVESEVEN,
	WEAPON_ELITE,
	WEAPON_P250,
	WEAPON_HKP2000,
	WEAPON_TEC9,
	WEAPON_M3,
	WEAPON_XM1014,
	WEAPON_NOVA,
	WEAPON_SAWEDOFF,
	WEAPON_AK47,
	WEAPON_M4A1,
	WEAPON_GALIL,
	WEAPON_GALILAR,
	WEAPON_FAMAS,
	WEAPON_SG552,
	WEAPON_SG556,
	WEAPON_AUG,
	WEAPON_SSG08,
	WEAPON_SCOUT,
	WEAPON_AWP,
	WEAPON_SG550,
	WEAPON_SCAR20,
	WEAPON_G3SG1,
	WEAPON_M249,
	WEAPON_NEGEV,
	WEAPON_MAG7,
	WEAPON_TMP,
	WEAPON_MAC10,
	WEAPON_MP5NAVY,
	WEAPON_MP7,
	WEAPON_BIZON,
	WEAPON_MP9,
	WEAPON_UMP45,
	WEAPON_P90,
	WEAPON_KNIFE,
	WEAPON_SHIELD,
	WEAPON_HEGRENADE,
	WEAPON_SMOKEGRENADE,
	WEAPON_FLASH,
	WEAPON_DECOY,
	WEAPON_INCENDIARY,
	WEAPON_MOLOTOV,
	WEAPON_C4,
	WEAPON_VEST,
	WEAPON_VESTHELM,
	WEAPON_NVGS,
	WEAPON_DEFUSER
};

enum WeaponType
{
	WeaponTypePistol,
	WeaponTypeSMG,
	WeaponTypeShotgun,
	WeaponTypeRifle,
	WeaponTypeSniper,
	WeaponTypeGrenade,
	WeaponTypeArmor,
	WeaponTypeMachineGun,
	WeaponTypeKnife,
	WeaponTypeOther,
	WeaponTypeShield,
	WeaponTypeNone
};

enum WeaponSlot
{
	SlotNone = -1,
	SlotPrimmary = 0,
	SlotPistol = 1,
	SlotKnife = 2,
	SlotGrenade = 3,
	SlotC4 = 4,
	SlotUnknown = 5
};

enum WeaponTeam
{
	UnknownTeam = -1,
	BothTeams = 0,
	TerrorTeam = 2,
	CTerrorTeam = 3
};

enum WeaponInfo
{
	WeaponID:InfoID,
	WeaponSlot:InfoSlot,
	WeaponType:InfoType,
	InfoTeam
};

new const String:weaponNames[_:WeaponID][] = 
{
	"none",			"glock",			"usp",			"p228",
	"deagle",		"fiveseven",		"elite",		"p250",
	"hkp2000",		"tec9",				"m3",			"xm1014",
	"nova",			"sawedoff",			"ak47",			"m4a1",
	"galil",		"galilar",			"famas",		"sg552",
	"sg556",		"aug",				"ssg08",		"scout",
	"awp",			"sg550",			"scar20",		"g3sg1",
	"m249",			"negev",			"mag7",			"tmp",
	"mac10",		"mp5navy",			"mp7",			"bizon",
	"mp9",			"ump45",			"p90",			"knife",
	"shield",		"hegrenade",		"smokegrenade",	"flashbang",	
	"decoy",		"incgrenade",		"molotov",		"c4",
	"vest",			"vesthelm",			"nvgs",			"defuser"
};

new const iMaxAmmo[_:WeaponID] = 
{
	-1,		120,	100,	52,
	21,		100,	120,	52,
	52,		120,	32,		32,
	32,		32,		90,		90,
	90,		90,		90,		90,
	90,		90,		90,		30,
	30,		90,		90,		90,
	200,	200,	32,		120,
	100,	120,	120,	120,
	120,	100,	100,	-1,
	-1,		-1,		-1,		-1,	
	-1,		-1,		-1,		-1,	
	-1,		-1,		-1,		-1
};

new const iMaxClipAmmo[_:WeaponID] = 
{
	-1,		20,		12,		13,
	7,		20,		30,		13,
	13,		32,		8,		7,
	8,		7,		30,		30,
	35,		35,		25,		30,
	30,		30,		10,		10,
	10,		30,		30,		30,
	100,	160,	5,		30,
	100,	30,		30,		64,
	30,		25,		50,		-1,
	-1,		-1,		-1,		-1,	
	-1,		-1,		-1,		-1,	
	-1,		-1,		-1,		-1
};

new const WeaponType:weaponGroups[_:WeaponID] =
{
	_:WeaponTypeNone,			_:WeaponTypePistol,			_:WeaponTypePistol,			_:WeaponTypePistol,
	_:WeaponTypePistol,			_:WeaponTypePistol,			_:WeaponTypePistol,			_:WeaponTypePistol,
	_:WeaponTypePistol,			_:WeaponTypePistol,			_:WeaponTypeShotgun, 		_:WeaponTypeShotgun,
	_:WeaponTypeShotgun,		_:WeaponTypeShotgun,		_:WeaponTypeRifle,			_:WeaponTypeRifle,
	_:WeaponTypeRifle,			_:WeaponTypeRifle,			_:WeaponTypeRifle,			_:WeaponTypeRifle,
	_:WeaponTypeRifle,			_:WeaponTypeRifle,			_:WeaponTypeSniper,			_:WeaponTypeSniper,
	_:WeaponTypeSniper,			_:WeaponTypeSniper,			_:WeaponTypeSniper,			_:WeaponTypeSniper,
	_:WeaponTypeMachineGun,		_:WeaponTypeMachineGun,		_:WeaponTypeShotgun,		_:WeaponTypeSMG,
	_:WeaponTypeSMG,			_:WeaponTypeSMG,			_:WeaponTypeSMG,			_:WeaponTypeSMG,
	_:WeaponTypeSMG,			_:WeaponTypeSMG,			_:WeaponTypeSMG,			_:WeaponTypeKnife,
	_:WeaponTypeShield,			_:WeaponTypeGrenade,		_:WeaponTypeGrenade,		_:WeaponTypeGrenade,
	_:WeaponTypeGrenade,		_:WeaponTypeGrenade,		_:WeaponTypeGrenade,		_:WeaponTypeOther,
	_:WeaponTypeArmor,			_:WeaponTypeArmor,			_:WeaponTypeOther,			_:WeaponTypeOther
};

new const WeaponSlot:weaponSlots[_:WeaponID] =
{
	_:SlotUnknown,		_:SlotPistol,		_:SlotPistol,		_:SlotPistol,
	_:SlotPistol,		_:SlotPistol,		_:SlotPistol,		_:SlotPistol,
	_:SlotPistol,		_:SlotPistol,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,
	_:SlotPrimmary,		_:SlotPrimmary,		_:SlotPrimmary,		_:SlotKnife,		
	_:SlotUnknown,		_:SlotGrenade,		_:SlotGrenade,		_:SlotGrenade,	
	_:SlotGrenade,		_:SlotGrenade,		_:SlotGrenade,		_:SlotC4,
	_:SlotNone,			_:SlotNone,			_:SlotNone,			_:SlotNone
};

new const BuyTeams[_:WeaponID] = 
{
	_:UnknownTeam,	_:BothTeams,	_:BothTeams,	_:BothTeams,
	_:BothTeams,	_:BothTeams,	_:BothTeams,	_:BothTeams,
	_:CTerrorTeam,	_:TerrorTeam,	_:BothTeams,	_:BothTeams,
	_:BothTeams,	_:TerrorTeam,	_:TerrorTeam,	_:CTerrorTeam,
	_:TerrorTeam,	_:TerrorTeam,	_:CTerrorTeam,	_:TerrorTeam,
	_:TerrorTeam,	_:CTerrorTeam,	_:BothTeams,	_:BothTeams,
	_:BothTeams,	_:CTerrorTeam,	_:CTerrorTeam,	_:TerrorTeam,
	_:BothTeams,	_:BothTeams,	_:CTerrorTeam,	_:CTerrorTeam,
	_:TerrorTeam,	_:BothTeams,	_:BothTeams,	_:BothTeams,
	_:CTerrorTeam,	_:BothTeams,	_:BothTeams,	_:BothTeams,
	_:UnknownTeam,	_:BothTeams,	_:BothTeams,	_:BothTeams,
	_:BothTeams,	_:CTerrorTeam,	_:TerrorTeam,	_:TerrorTeam,
	_:BothTeams,	_:BothTeams,	_:BothTeams,	_:CTerrorTeam
};

stock CSWeapons_Init()
{
	if(hWeaponInfoTrie == INVALID_HANDLE)
	{
		InitWeaponInfoTrie();
	}
}

stock InitWeaponInfoTrie()
{
	hWeaponInfoTrie = CreateTrie();
	new info[WeaponInfo];
	for(new i = 0; i < _:WeaponID; i++)
	{
		info[InfoID] = WeaponID:i;
		info[InfoSlot] = weaponSlots[WeaponID:i];
		info[InfoType] = weaponGroups[WeaponID:i];
		info[InfoTeam] = BuyTeams[WeaponID:i];
		
		SetTrieArray(hWeaponInfoTrie, weaponNames[WeaponID:i], info[0], _:WeaponInfo);
	}
}
	
stock WeaponID:GetWeaponID(const String:weapon[])
{
	decl info[WeaponInfo];
	if(GetWeaponInfo(weapon, info))
		return info[InfoID];
	
	return WEAPON_NONE;
}

stock WeaponSlot:GetWeaponSlot(const String:weapon[])
{
	decl info[WeaponInfo];
	if(GetWeaponInfo(weapon, info))
		return info[InfoSlot];
	
	return SlotUnknown;
}

stock GetMaxWeaponAmmo(const String:weapon[])
{
	new WeaponID:id = GetWeaponID(weapon);
	
	return iMaxAmmo[id];
}

stock GetMaxClipWeaponAmmo(const String:weapon[])
{
	new WeaponID:id = GetWeaponID(weapon);
	
	return iMaxClipAmmo[id];
}

stock WeaponType:GetWeaponType(const String:weapon[])
{
	decl info[WeaponInfo];
	if(GetWeaponInfo(weapon, info))
		return info[InfoType]
	
	return WeaponTypeNone;
}

stock String:GetWeaponNameByEnt(iEnt, String:weapon[], size)
{
	GetEntPropString(iEnt, Prop_Data, "m_iClassname", weapon, size);
	return weapon;
}

stock bool:CanTeamBuyWeapon(team, const String:weapon[])
{
	if(team < _:TerrorTeam || team > _:CTerrorTeam)
		return true;
	
	decl info[WeaponInfo];
	if(GetWeaponInfo(weapon, info))
	{
		if(info[InfoTeam] == 0 || info[InfoTeam] == team)
			return true;
		
		return false;
	}
	return true;
}

stock GetWeaponPriceFromName(client, const String:weapon[], bool:defaultprice=false)
{
	new WeaponID:id = GetWeaponID(weapon);
	
	return GetWeaponPrice(client, id, defaultprice);
}

stock GetWeaponPrice(client, WeaponID:id, bool:defaultprice=false)
{	
	if(id > WEAPON_DEFUSER || id == WEAPON_NONE)
		return 0;
	if(id == WEAPON_DEFUSER)
		return 200;
	
	return CS_GetWeaponPrice(client, CSWeaponID:_:id, defaultprice);
}

stock WeaponSlot:GetSlotFromWeaponID(WeaponID:id)
{
	return weaponSlots[_:id]
}

stock WeaponType:GetWeaponTypeFromID(WeaponID:id)
{
	return weaponGroups[_:id]
}

stock bool:GetWeaponInfo(const String:weapon[], info[WeaponInfo])
{
	if(hWeaponInfoTrie == INVALID_HANDLE)
		InitWeaponInfoTrie();
	
	decl String:CheckWeapon[64];
	strcopy(CheckWeapon, sizeof(CheckWeapon), weapon);
	new len = strlen(weapon);
	for(new i = 0; i < len; i++)
	{
		CheckWeapon[i] = CharToLower(weapon[i]);
	}

	if(GetTrieArray(hWeaponInfoTrie, CheckWeapon, info[0], _:WeaponInfo))
		return true;
	
	if(ReplaceString(CheckWeapon, sizeof(CheckWeapon), "weapon_", "", false) == 1 || ReplaceString(CheckWeapon, sizeof(CheckWeapon), "item_", "", false) == 1)
	{
		if(GetTrieArray(hWeaponInfoTrie, CheckWeapon, info[0], _:WeaponInfo))
			return true;
	}
	
	return false;
}